DelayUs:MACRO T ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
    errorlevel -207		    ; for code justifying
    
    if T >= (256*197122)+7
	error "Too large T value"
	exitm
    endif
    
    local t = (T)
    local w

    w = ((t-C3) / T3)
    
    if w > 0
	MOVLW	w
	MOVWF	delay1_cnt
	CALL	delaySec
	t = ((t-C3) % T3)
    endif
    
    w = (((t)-C2) / T2)

    if w > 0
	MOVLW	w
	MOVWF	delay1_cnt
	CALL	delayMsF
	t = (((t)-C2) % T2)
    endif

    w = (((t)-C1) / T1)
    
    if w > 0
	MOVLW	w
	MOVWF	delay1_cnt
	CALL	delayUsF
	t = (((t)-C1) % T1)
    endif
    
    w = t
    
    while w > 1
	GOTO	$+1
	w -= 2
    endw
    
    while w > 0
	NOP
	w -= 1
    endw
    
    errorlevel +207		    ; for code justifying
    ENDM

#define FC (1) ; fclk [MHz]    
    
#define C1  (5/FC)
#define T1  (3/FC)
;#define T1  (4/FC) IF CLRWDT inside
delayUsF: ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;    CLRWDT
    DECFSZ	delay1_cnt,F
    GOTO	delayUsF
    RETLW	0

#define C2    (6/FC)
#define T2    (770/FC)
;#define T2    (1026/FC) IF CLRWDT inside
delayMsF: ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
    CLRF	delay2_cnt
delayMsFStart:    
;    CLRWDT
    DECFSZ	delay2_cnt,F
    GOTO	delayMsFStart
    DECFSZ	delay1_cnt,F
    GOTO	delayMsFStart
    RETLW	0
    
#define C3    (7/FC)
#define T3    (197122/FC)
;#define T3    (262658/FC) IF CLRWDT inside
delaySec: ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
    CLRF	delay2_cnt
    CLRF	delay3_cnt
delaySecStart:
;    CLRWDT
    DECFSZ	delay3_cnt,F
    GOTO	delaySecStart
    DECFSZ	delay2_cnt,F
    GOTO	delaySecStart
    DECFSZ	delay1_cnt,F
    GOTO	delaySecStart
    RETLW	0

SetPinH:MACRO PIN_NAME ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
    BSF		GPIO, PIN_NAME
    BCF		tris_reg, PIN_NAME
    MOVF	tris_reg,W
    TRIS	GPIO
    
    ENDM
    
SetPinL:MACRO PIN_NAME ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
    BCF		GPIO, PIN_NAME
    BCF		tris_reg, PIN_NAME
    MOVF	tris_reg,W
    TRIS	GPIO
    ENDM
    
SetPinHZ:MACRO PIN_NAME ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
    BSF		tris_reg, PIN_NAME
    MOVF	tris_reg,W
    TRIS	GPIO
    ENDM
    
    
OwOutHZ:MACRO ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
    SetPinHZ DS18B20_PIN
    ENDM

OwOutL:MACRO ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
    SetPinL DS18B20_PIN
    ENDM

OwOutH:MACRO ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
    SetPinH DS18B20_PIN
    ENDM  
    
CapOutH:MACRO ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
    SetPinH CAP_PIN
    ENDM

CapOutL:MACRO   
    SetPinL CAP_PIN
    ENDM
    
CapOutHZ:MACRO
    SetPinHZ CAP_PIN
    ENDM    
    
; jump to label G if R is less than L
JL:MACRO R, L, G
    MOVLW	L
    SUBWF	R,W
    BTFSS	STATUS,C
    GOTO	G
    ENDM

; jump to label G if R is less than L or equals
JLE:MACRO R, L, G
    MOVLW	L
    ADDWF	ONE,W
    BTFSC	STATUS,Z
    GOTO	G
    SUBWF	R,W
    BTFSS	STATUS,C
    GOTO	G    
    ENDM
    
; jump to label G if R is grather than L    
JG:MACRO R, L, G
    MOVLW	L
    ADDWF	ONE,W
    BTFSC	STATUS,Z
    GOTO	JG_END
    SUBWF	R,W
    BTFSC	STATUS,C
    GOTO	G
JG_END:    
    ENDM

    
; jump to label G if R is grather than L or equals
JGE:MACRO R, L, G
    MOVLW	L
    SUBWF	R,W
    BTFSC	STATUS,C
    GOTO	G        
    ENDM

SetAlarmPin:macro
    BCF		GPIO, ALARM_PIN
    endm

ClearAlarmPin:macro
    BSF		GPIO, ALARM_PIN
    endm
    